#include "rclcpp/rclcpp.hpp"
{% for d in data %}
#include "{{ pkgname }}/srv/get_{{ d.name }}_data.hpp"
{% if d.type in typemap %}{% else %}{% do typemap.update({d.type: d.type}) %}{% endif %}
#include "{{ typemap[d.type]|ros2_message_header }}.hpp"
{% endfor %}

using std::placeholders::_1;
using std::placeholders::_2;

class {{ skillset|capitalize }}DataManager : public rclcpp::Node {
private:
  {% for d in data %}// {{ d.name  }} data
  {{ typemap[d.type]|ros2_message_class }} {{ d.name }}_;
  bool {{ d.name }}_received_;
  rclcpp::Subscription<{{ typemap[d.type]|ros2_message_class }}>::SharedPtr {{ d.name }}_subscriber_;
  rclcpp::Service<{{ pkgname }}::srv::Get{{ d.name|data_name }}Data>::SharedPtr {{ d.name }}_service_;
  {% endfor %}
  {% for d in data %}
  void {{ d.name }}_callback(const {{ typemap[d.type]|ros2_message_class }}::SharedPtr msg)
  {
    RCLCPP_DEBUG(rclcpp::get_logger("data_manager"), "received data {{ d.name }}");
    this->{{ d.name }}_received_ = true;
    this->{{ d.name }}_ = *msg;
  }

  bool get_{{ d.name }}_callback(const std::shared_ptr<{{ pkgname }}::srv::Get{{ d.name|data_name }}Data::Request> request,
    std::shared_ptr<{{ pkgname }}::srv::Get{{ d.name|data_name }}Data::Response> response)
  {
    (void)request; // remove unused warning
    if (this->{{ d.name }}_received_) {
      response->data = this->{{ d.name }}_;
      return true;
    }
    else return false;
  }
  {% endfor %}

public:
  explicit {{ skillset|capitalize }}DataManager() 
    : rclcpp::Node("data_manager")
  {
    {% for d in data %}
    this->{{ d.name }}_received_ = false;
    this->{{ d.name }}_subscriber_ = this->create_subscription<{{ typemap[d.type]|ros2_message_class }}>(
      "data/{{ d.name }}", 1, 
      std::bind(&{{ skillset|capitalize }}DataManager::{{ d.name }}_callback, this, _1));
    this->{{ d.name }}_service_ =  this->create_service<{{ pkgname }}::srv::Get{{ d.name|data_name }}Data>("data/get_{{ d.name }}",
      std::bind(&{{ skillset|capitalize }}DataManager::get_{{ d.name }}_callback, this, _1, _2));
    {% endfor %}
  }

};

int main(int argc, char **argv)
{
  rclcpp::init(argc, argv);
  auto manager = std::make_shared<{{ skillset|capitalize }}DataManager>();
  RCLCPP_DEBUG(rclcpp::get_logger("data_manager"), "Data Manager ready");
  rclcpp::spin(manager);
  rclcpp::shutdown();
  return 0;
}
